Subject: Re: A future for the SSH File Transfer Protocol?

From: Jeffrey Altman <[email-masked]>
Date: Thu, 8 Nov 2001 11:15:55 EST

The reality is that a client should not have any idea what the
"realpath" means on the server.  This plus the notion of providing
access to uid/gid numbers is crazy when the world is not made up
entirely of Unix systems. 

How is FXP_REALPATH("~fred") different then GETHOME("fred") in regards
to how you are going to deal with it?

> Jeffrey Altman <[email-masked]> wrote:
> 
> > Why should a client ever have to understand a system dependent alias
> > such as ~fred?
> > 
> > The only entity that should need to know how to map ~fred to what it
> > points to is the sender of the file.
> 
> Ah; you think it would be better for servers to understand `~fred'
> at the start of a pathname?
> 
> Fair enough, I suppose. But the rest of the ethos of SFTP seems to
> be that whatever alias or synonym you use to refer to a directory,
> you can always call FXP_REALPATH and get the full canonical name. So
> in my command-line SFTP client, I don't want to type `cd ~fred' and
> then have `pwd' just tell me `~fred'; I'd rather get the same
> behaviour I get at the real shell prompt, where I type `cd ~fred'
> and `pwd' tells me `/home/fred'.
> 
> I suppose that could be done just by making the server understand
> `~fred' at the start of a pathname, and then having the client call
> FXP_REALPATH("~fred") if it wanted the canonical form; but that
> starts to eat into the available characters in filenames, which is
> something SFTP has so far been scrupulous in not doing. So instead,
> my proposal was to introduce a protocol extension which allowed the
> client side to request the home directory of a particular user.
> 
> While I was at it, I also added name<->number mappings for users and
> groups, on the grounds that it seems silly that a command-line
> client can list the textual usernames of file owners by printing out
> the long name field, but a GUI client wanting to split all the
> details into separate columns has to make do with the numbers.
> 
> Cheers,
> Simon
> -- 
> Simon Tatham         "A cynic is a person who smells flowers and
> <[email-masked]>    immediately looks around for a coffin."
> 

 Jeffrey Altman * Sr.Software Designer      C-Kermit 8.0 Beta available
 The Kermit Project @ Columbia University   includes Secure Telnet and FTP
 http://www.kermit-project.org/             using Kerberos, SRP, and 
 [email-masked]          OpenSSL.  SSH soon to follow.

---

From: Darren Moffat <[email-masked]>
Date: Mon, 12 Nov 2001 10:46:21 -0800 (PST)

>On Mon, Nov 12, 2001 at 09:34:31AM -0800, Darren J Moffat wrote:
>> 
>> To that end there has been proposals to change this area of
>> the protocol and augment it with a method for the client to translate
>> the opaque uid into a name suitable for display.  The rational being
>> that the mapping maybe different on the client than on the server.
> 
>It strikes me that the whole notion of internal uid is the wrong way
>to go and just makes life complex for both client and server.  I'd
>propose instead that all conversation be in terms of external
>user/group names.  If people really want to optimize directory listings,

I agree and this is why I said SFTP was starting to look like NFS + NIS,
if this is a file transfer protocol it shouldn't need this information
particularly if it is expected not to make any sense in the clients domain
anyway.

--
Darren J Moffat